SystemOrganization addCategory: #'HealthReportProducer-Core'!
SystemOrganization addCategory: #'HealthReportProducer-Example'!
SystemOrganization addCategory: #'HealthReportProducer-Example-Tests'!

Object subclass: #HealthReportProducer
	instanceVariableNames: 'progressBarCurrentValue result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HealthReportProducer-Core'!

HealthReportProducer subclass: #CollectionHealth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HealthReportProducer-Example'!

!CollectionHealth commentStamp: 'AlexandreBergel 12/30/2010 12:06' prior: 0!
CollectionHealth new produceReport.

CollectionHealth new runAndWriteResultInFileNamed: 'file.txt'
!

!CollectionHealth methodsFor: 'structural' stamp: 'AlexandreBergel 12/30/2010 11:30'!
metricNumberOfClasses
	<description: 'Number of Classes (NOC)'>
	^ self classes size! !

!CollectionHealth methodsFor: 'structural' stamp: 'AlexandreBergel 12/30/2010 11:30'!
metricNumberOfMethods
	<description: 'Number of Methods (NOM)'>
	^ self methods size! !

!CollectionHealth methodsFor: 'structural' stamp: 'AlexandreBergel 12/30/2010 11:30'!
metricNumberOfPackages
	<description: 'Number of Packages'>
	^ self packages size! !

!CollectionHealth methodsFor: 'benchmark' stamp: 'AlexandreBergel 12/30/2010 11:41'!
metricReverseInterval
	<description: 'Reverse Interval'>
	^ [ (1 to: 30000) reverse reverse reverse reverse ] timeToRun! !

!CollectionHealth methodsFor: 'util' stamp: 'AlexandreBergel 12/30/2010 11:58'!
packages
	^ { PackageInfo named: 'CollectionsTests-Arrayed' .  PackageInfo named: 'Collections-Arrayed' }
	"^ PackageInfo allPackages select: [ :p | 'HealthReportProducer*' match: p packageName ]
	
"! !

!HealthReportProducer classSide methodsFor: 'public' stamp: 'Ivan Rojas 3/9/2011 16:00'!
writeReportForMrHolmesForProject: packageName
	! !

!HealthReportProducer methodsFor: 'public - hook' stamp: 'AlexandreBergel 12/30/2010 11:32'!
classes
	"Return the list of the classes to profile"
	| answer |
	answer := OrderedCollection new.
	self packages do: [ :p | answer addAll: p classes ].
	^ answer
! !

!HealthReportProducer methodsFor: 'progress bar' stamp: 'Alexandre Bergel 1/16/2010 14:19'!
displayProgressBar: aBlock size: size titled: title

	progressBarCurrentValue := 1.
	title
		displayProgressAt: Display center
		from: 0 to: size
		during: [:bar | aBlock value: bar ]
! !

!HealthReportProducer methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 12/30/2010 11:19'!
getResultAsDictionary
	^ result! !

!HealthReportProducer methodsFor: 'progress bar' stamp: 'Alexandre Bergel 1/16/2010 14:19'!
incrProgressBar: bar
	progressBarCurrentValue :=  progressBarCurrentValue + 1.
	bar value: progressBarCurrentValue.
! !

!HealthReportProducer methodsFor: 'initialize-release' stamp: 'Ivan Rojas 3/4/2011 12:04'!
initialize
	super initialize.
	result := Dictionary new.
	result at: #'Date' put: Date dateAndTimeNow! !

!HealthReportProducer methodsFor: 'logging' stamp: 'Alexandre Bergel 1/16/2010 14:23'!
log: object named: title
	| selectorName source newSource |
	selectorName := (#log, title) asSymbol.
	(self class includesSelector: selectorName)
		ifFalse: [ self class compile: selectorName, String cr, String cr, '	^ #()', String cr.
					  self class organization classify: selectorName under: 'logging'].

	source := (self class >> selectorName) getSourceFromFile.
	newSource := source , '	,#(#(', object printString, ' ''', title, '''))'.
	self class compile: newSource.! !

!HealthReportProducer methodsFor: 'logging' stamp: 'Alexandre Bergel 1/16/2010 14:24'!
logMethodCoverage
	^ #()! !

!HealthReportProducer methodsFor: 'public - hook' stamp: 'AlexandreBergel 12/30/2010 11:38'!
methods
	"Return the list of method to profile"
	| answer |
	answer := OrderedCollection new.
	self packages do: [ :p | answer addAll: (p methods collect: #compiledMethod) ].
	^ answer
! !

!HealthReportProducer methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 3/2/2011 15:41'!
numberOfLinesOfCode
	^ self methods inject: 0 into: 
		[ :sum :el | sum + el numberOfLinesOfCode ]
! !

!HealthReportProducer methodsFor: 'util' stamp: 'Ivan Rojas 12/28/2010 16:43'!
openMondrianGraphOn: associations titled: titleAsString

"	| view |
	view := MOViewRenderer new.


	view node: #foo forIt: [
		view layout: (MOScatterplotLayout new x: #key; y: #value; scaleFactorX: 0.10; scaleFactorY: 0.10 ).
		view interaction popupText: [:element | element key printString, ' nodes => ', element value printString, ' ms' ].
		view nodes: associations.
	
	].
	view open"! !

!HealthReportProducer methodsFor: 'util' stamp: 'Alexandre Bergel 1/16/2010 14:25'!
openWorkspaceWith: stream
	Workspace new contents: (stream contents); openLabel: 'Mondrian health report'.! !

!HealthReportProducer methodsFor: 'public - hook' stamp: 'AlexandreBergel 12/30/2010 11:32'!
packages
	"Need to return the list of package info of the application to profile"

	"For example:
	^ PackageInfo allPackages select: [ :p | 'Collection*' match: p packageName ]
	"

	self subclassResponsibility
	
! !

!HealthReportProducer methodsFor: 'public - vermon' stamp: 'AlexandreBergel 12/30/2010 11:26'!
produceReport
	"
	self new produceReport
	"
	| stream |
	stream := WriteStream on: String new.
	self produceReportOn: stream.	
	self openWorkspaceWith: stream.
! !

!HealthReportProducer methodsFor: 'public - vermon' stamp: 'AlexandreBergel 12/30/2010 11:26'!
produceReportInFileNamed: filename
	"
	self new produceReportInFileNamed: 'file.txt'
	"
	| stream |
	stream := FileStream forceNewFileNamed: filename. 
	[ self produceReportOn: stream.	
	  self openWorkspaceWith: stream ]
		ensure: [ stream ifNotNil: [ stream close ] ]
! !

!HealthReportProducer methodsFor: 'public - vermon' stamp: 'AlexandreBergel 9/16/2010 12:06'!
produceReportOn: stream
	self writeBenchmarksExecutionOn: stream.! !

!HealthReportProducer methodsFor: 'action' stamp: 'MrHolmes 3/14/2011 12:00'!
run
	(self classes select: [ :cls | cls inheritsFrom: HealthReportProducer ])
		do: [ :cls | self runBenchmarksForClass: cls ].
	"self runBenchmarks."
	self runUnitTests! !

!HealthReportProducer methodsFor: 'public' stamp: 'AlexandreBergel 12/30/2010 12:06'!
runAndWriteResultInFileNamed: filename
	"
	self new writeResultInFileNamed: 'file.txt'
	"
	self 
		run;
		writeResultInFileNamed: filename! !

!HealthReportProducer methodsFor: 'public' stamp: 'AlexandreBergel 12/30/2010 12:05'!
runAndWriteResultInStream: stream
	self 
		run;
		writeResultInStream: stream  ! !

!HealthReportProducer methodsFor: 'benchmarks' stamp: 'AlexandreBergel 12/30/2010 11:49'!
runBenchmarks
	"execute benchmarks and store the result in a dictionary (held by the result variable)"
	| tmpResult description pragma |
	(self class selectors select: [ :sel | (sel beginsWith: #benchmark) or: [ sel beginsWith: #metric ]]) asSortedCollection 
		do: [ :selector |
			tmpResult := self perform: selector.
			pragma := (self class>>selector) pragmaAt: #description:.
			description := pragma 
							ifNil: [ selector ]
							ifNotNil: [ pragma arguments first ].
			result at: description put: tmpResult.
		]! !

!HealthReportProducer methodsFor: 'benchmarks' stamp: 'MrHolmes 3/14/2011 11:59'!
runBenchmarksForClass: aClass
	"execute benchmarks and store the result in a dictionary (held by the result variable)"
	| tmpResult description pragma instance |
	instance := aClass new.
	(aClass selectors select: [ :sel | (sel beginsWith: #benchmark) or: [ sel beginsWith: #metric ]]) asSortedCollection 
		do: [ :selector |
			tmpResult := instance perform: selector.
			pragma := (aClass>>selector) pragmaAt: #description:.
			description := pragma 
							ifNil: [ selector ]
							ifNotNil: [ pragma arguments first ].
			result at: description put: tmpResult.
		]! !

!HealthReportProducer methodsFor: 'action' stamp: 'AlexandreBergel 12/30/2010 12:49'!
runUnitTests
	| testResult |
	"result at: 'Passed tests' put: OrderedCollection new."
	result at: 'Error tests' put: OrderedCollection new.
	result at: 'Failed tests' put: OrderedCollection new.
	result at: 'Number of passed tests' put: 0.
	
	self unitTests do: [ :cls | 
		testResult := cls buildSuite run.
		(result at: 'Number of passed tests' put: ((result at: 'Number of passed tests') + (testResult passed size))).
		(result at: 'Error tests') addAll: (testResult errors collect: #asString).
		(result at: 'Failed tests') addAll: (testResult failures collect: #asString).
		] ! !

!HealthReportProducer methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 12/30/2010 11:34'!
unitTests
	"Answer the list of unit tests defined in the application to profile"
	
	^ self classes select: [ :cls | cls inheritsFrom: TestCase  ]! !

!HealthReportProducer methodsFor: 'benchmarks' stamp: 'Ivan Rojas 12/28/2010 16:45'!
writeBenchmarksExecutionOn: stream
	"execute benchmarks and write a report on the stream"
	| resultTmp description |
	(self class selectors select: [ :sel | (sel beginsWith: #benchmark) or: [ sel beginsWith: #metric ]]) asSortedCollection 
		do: [ :selector |
			resultTmp := self perform: selector.
			description := (self class>>selector) propertyValueAt: #description: ifAbsent: [ selector ].
			stream 
				nextPutAll: description;
				nextPutAll: ' => ';
				nextPutAll: resultTmp asString; 
				cr.
			result at: description put: resultTmp.
		]! !

!HealthReportProducer methodsFor: 'report producers' stamp: 'Alexandre Bergel 1/16/2010 14:32'!
writeCoverageInfoOn: stream
	| testClasses packageType ratioCoveredMethods lastCoverage diff diffAsString typeClass |
	typeClass := Smalltalk at: #CoveragePackageSpy
		ifAbsent:
			[ self inform: 'The coverage is realized by the tool Spy. Please download it from www.squeaksource.com/Spy.html'.
			^ self ].	"We run the test"
	self displayProgressBar:
			[ :bar | 
			ratioCoveredMethods := (typeClass forPackagesMatching: 'Mondrian*' atEachTestEvaluate: [ self incrProgressBar: bar ])
				ratioCoveredMethods ]
		size: (typeClass numberOfTestUnitClassesInPackagesMatching: 'Mondrian*')
		titled: 'Coverage from test'.
	stream
		nextPutAll: ratioCoveredMethods printString;
		nextPutAll: '  % of methods are covered';
		cr.	"Compute the coverage"
	lastCoverage := self logMethodCoverage last first.
	diff := ratioCoveredMethods - lastCoverage.
	diff := ((diff * 100) asInteger / 100) asFloat.
	diffAsString := diff > 0 ifTrue: [ '+' , diff printString ] ifFalse: [ diff printString ].
	stream
		nextPutAll: 'Progress from last time: ' , diffAsString;
		nextPutAll: ' %'.
	stream cr.
	self log: ratioCoveredMethods named: 'MethodCoverage'! !

!HealthReportProducer methodsFor: 'report producers' stamp: 'Alexandre Bergel 7/16/2010 09:08'!
writeGeneralInfoOn: stream
	stream
		nextPutAll: 'Report produced on ';
		nextPutAll: DateAndTime now printString;
		cr.

	stream
		nextPutAll: 'System version ';
		nextPutAll: SystemVersion current printString;
		cr! !

!HealthReportProducer methodsFor: 'public' stamp: 'Ivan Rojas 3/9/2011 16:46'!
writeResultInFileNamed: filename

	| stream |
	(FileStream isAFileNamed: filename) ifTrue: [
		stream := FileStream fileNamed: filename.
		stream setToEnd.
		[ self writeResultInStream: stream ]
			 ensure: [ stream ifNotNil: [ stream close ]]
		] ifFalse: [
			stream := FileStream forceNewFileNamed: filename. 
			[ self writeResultInStream: stream ]
			 ensure: [ stream ifNotNil: [ stream close ]]]


	
! !

!HealthReportProducer methodsFor: 'public' stamp: 'Ivan Rojas 3/4/2011 12:07'!
writeResultInStream: aStream
	
	| resultXML attributes |
	resultXML := ((XMLWriter new)
		enablePrettyPrinting;
		writeWith: [ :writer |
			attributes := (Dictionary new).
			attributes at: 'Date' put: Date today asString.
			attributes at: 'Time' put: Time now asString.
			writer tag: 'Result' attributes: attributes with: [ writer tag: 'Details' with: (result storeString)]];
		yourself) asString.
	
	aStream nextPutAll: resultXML, String cr.
! !

HealthReportProducer subclass: #HealthReportProducerGeneric
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HealthReportProducer-Core'!

!HealthReportProducerGeneric methodsFor: 'initialization' stamp: 'Ivan Rojas 3/9/2011 16:04'!
packageName: aPackageName
	package := PackageInfo allPackages select: [ :pak | pak packageName beginsWith: aPackageName ]
! !

!HealthReportProducerGeneric methodsFor: 'initialization' stamp: 'Ivan Rojas 3/9/2011 16:04'!
packages
	 ^ package ! !

TestCase subclass: #CollectionHealthTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HealthReportProducer-Example-Tests'!

!CollectionHealthTest commentStamp: 'AlexandreBergel 12/30/2010 11:03' prior: 0!
Unit test for the class CollectionHealth. This unit test is used as a test for the super class,  HealthReportProducer

AlexandreBergel 12/30/2010 11:03!

!CollectionHealthTest methodsFor: 'basic' stamp: 'AlexandreBergel 12/30/2010 11:17'!
testBasic

	| stream |
	stream := WriteStream on: String new.
	CollectionHealth new produceReportOn: stream.
	self assert: ((stream contents substrings ) includesAllOf: #('metricNumberOfClasses' 'metricNumberOfMethods' 'metricNumberOfPackages' 'metricReverseInterval' '=>'))
! !

!CollectionHealthTest methodsFor: 'basic' stamp: 'Ivan Rojas 3/4/2011 12:19'!
testClasses
	| classes classesToCheck |

	classes := CollectionHealth new classes.
	
	classesToCheck :=  #( #ArrayTest  #ByteArrayTest #WordArray) 
							select: [ :clsName | Smalltalk globals includesKey: clsName ] 
							thenCollect: [ :clsName | Smalltalk globals at: clsName ].
	self assert: (classes includesAllOf: classesToCheck)! !

!CollectionHealthTest methodsFor: 'basic' stamp: 'Ivan Rojas 3/4/2011 12:10'!
testDictionaryResult
	| dict |
	dict := CollectionHealth new run; getResultAsDictionary.
	
	self assert: (dict isDictionary).
	self assert: dict keys asSortedCollection asArray =  #('Date' 'Error tests' 'Failed tests' 'Number of Classes (NOC)' 'Number of Methods (NOM)' 'Number of Packages' 'Number of passed tests' 'Reverse Interval').
	
	self assert: (dict at: 'Number of Classes (NOC)') = CollectionHealth new classes size.
	self assert: (dict at: 'Failed tests') isCollection.
	self assert: (dict at: 'Date') = Date dateAndTimeNow ! !

!CollectionHealthTest methodsFor: 'basic' stamp: 'Ivan Rojas 3/28/2011 10:05'!
testDictionaryResultInStream
	| stream xmlDocument details aCollectionHealth |
	stream := WriteStream on: String new.
	aCollectionHealth := CollectionHealth new.
	aCollectionHealth run; writeResultInStream: stream.
	aCollectionHealth run; writeResultInStream: stream.
	aCollectionHealth run; writeResultInStream: stream.
	
	xmlDocument := XMLDOMParser parse: (stream contents).
      self assert: ((xmlDocument findElementNamed: 'Result') notNil). 

	self assert: ((xmlDocument allElementsNamed: 'Result') size = 3).

	xmlDocument allElementsNamed: 'Result' do: [ :result |
		self assert: ((result attributeAt: 'Date') = (Date today asString)).
		self assert: ((result attributeAt: 'Time') = (Time now asString)).
		details := (result elementAt: 'Details') contentString. 
		self assert: (details beginsWith: '((Dictionary new)')]
	
	"self assert: (stream contents  beginsWith: '((Dictionary new)')  "! !

!CollectionHealthTest methodsFor: 'basic' stamp: 'Ivan Rojas 3/28/2011 09:45'!
testDictionaryResultInStream2
	| stream xmlDocument details |
	stream := WriteStream on: String new.
	CollectionHealth new runAndWriteResultInStream: stream.
	
	xmlDocument := XMLDOMParser parse: (stream contents).
      self assert: ((xmlDocument findElementNamed: 'Result') notNil). 

	xmlDocument allElementsNamed: 'Result' do: [ :result |
		self assert: ((result attributeAt: 'Date') = (Date today asString)).
		self assert: ((result attributeAt: 'Time') = (Time now asString)).
		details := (result elementAt: 'Details') contentString. 
		self assert: (details beginsWith: '((Dictionary new)')].
	"self assert: (stream contents  beginsWith: '((Dictionary new)')" ! !

!CollectionHealthTest methodsFor: 'basic' stamp: 'Ivan Rojas 3/4/2011 12:20'!
testUnitTests
	| unitTests classesToCheck |

	unitTests := CollectionHealth new unitTests.
	classesToCheck :=  #( #ArrayTest  #ByteArrayTest #FloatArrayTest) 
							select: [ :clsName | Smalltalk globals includesKey: clsName ] 
							thenCollect: [ :clsName | Smalltalk globals at: clsName ].

	self assert: (unitTests includesAllOf: classesToCheck)! !
